Index: COPYING
===================================================================
--- COPYING	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ COPYING	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -909,5 +286,4 @@
 
 	    How to Apply These Terms to Your New Programs
->>>>>>> FETCH_HEAD
 
   If you develop a new program, and you want it to be of the greatest
@@ -917,23 +293,13 @@
   To do so, attach the following notices to the program.  It is safest
 to attach them to the start of each source file to most effectively
-<<<<<<< HEAD
-state the exclusion of warranty; and each file should have at least
-=======
 convey the exclusion of warranty; and each file should have at least
->>>>>>> FETCH_HEAD
 the "copyright" line and a pointer to where the full notice is found.
 
-    <one line to give the program's name and a brief idea of what it does.>
-    Copyright (C) <year>  <name of author>
-
-<<<<<<< HEAD
-    This program is free software: you can redistribute it and/or modify
-    it under the terms of the GNU General Public License as published by
-    the Free Software Foundation, either version 3 of the License, or
-=======
+    MoleCuilder - to create and alter molecular systems
+    Copyright (C) 2010  Frederik Heber
+
     This program is free software; you can redistribute it and/or modify
     it under the terms of the GNU General Public License as published by
     the Free Software Foundation; either version 2 of the License, or
->>>>>>> FETCH_HEAD
     (at your option) any later version.
 
@@ -944,15 +310,4 @@
 
     You should have received a copy of the GNU General Public License
-<<<<<<< HEAD
-    along with this program.  If not, see <http://www.gnu.org/licenses/>.
-
-Also add information on how to contact you by electronic and paper mail.
-
-  If the program does terminal interaction, make it output a short
-notice like this when it starts in an interactive mode:
-
-    <program>  Copyright (C) <year>  <name of author>
-    This program comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
-=======
     along with this program; if not, write to the Free Software
     Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301  USA
@@ -964,27 +319,12 @@
 when it starts in an interactive mode:
 
-    Gnomovision version 69, Copyright (C) year  name of author
-    Gnomovision comes with ABSOLUTELY NO WARRANTY; for details type `show w'.
->>>>>>> FETCH_HEAD
+    MoleCuilder version ??, Copyright (C) 2010  Frederik Heber
+    MoleCuilder comes with ABSOLUTELY NO WARRANTY; for details type 
+    `molecuilder --help-warranty'.
     This is free software, and you are welcome to redistribute it
-    under certain conditions; type `show c' for details.
+    under certain conditions; type `molecuilder --help-redistribute' 
+    for details.
 
 The hypothetical commands `show w' and `show c' should show the appropriate
-<<<<<<< HEAD
-parts of the General Public License.  Of course, your program's commands
-might be different; for a GUI interface, you would use an "about box".
-
-  You should also get your employer (if you work as a programmer) or school,
-if any, to sign a "copyright disclaimer" for the program, if necessary.
-For more information on this, and how to apply and follow the GNU GPL, see
-<http://www.gnu.org/licenses/>.
-
-  The GNU General Public License does not permit incorporating your program
-into proprietary programs.  If your program is a subroutine library, you
-may consider it more useful to permit linking proprietary applications with
-the library.  If this is what you want to do, use the GNU Lesser General
-Public License instead of this License.  But first, please read
-<http://www.gnu.org/philosophy/why-not-lgpl.html>.
-=======
 parts of the General Public License.  Of course, the commands you use may
 be called something other than `show w' and `show c'; they could even be
@@ -995,9 +335,8 @@
 necessary.  Here is a sample; alter the names:
 
-  Yoyodyne, Inc., hereby disclaims all copyright interest in the program
-  `Gnomovision' (which makes passes at compilers) written by James Hacker.
-
-  <signature of Ty Coon>, 1 April 1989
-  Ty Coon, President of Vice
+  University of Bonn, hereby disclaims all copyright interest in the program
+  `MoleCuilder' (which creates molecular systems) written by Frederik Heber.
+
+  Frederik Heber, 17 Aug 2010
 
 This General Public License does not permit incorporating your program into
@@ -1006,3 +345,2 @@
 library.  If this is what you want to do, use the GNU Library General
 Public License instead of this License.
->>>>>>> FETCH_HEAD
Index: Makefile.am
===================================================================
--- Makefile.am	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ Makefile.am	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -9,2 +9,5 @@
 doc:
 	cd doc && make doxygen-docs
+	
+unity:
+	cd src && make unity
Index: README
===================================================================
--- README	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ README	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,45 +1,27 @@
-<<<<<<< HEAD
-# Project: Molecuilder
+# Project: MoleCuilder
 #
 # heber@ins.uni-bonn.de
 
-	Molecuilder
+	MoleCuilder
 
-... is a tool that started as a mean to edit pcp configuration files (adding/remvoing groups of atoms, measuring bond lengths and so forth) and has grown into the many-body fragmentation test base of a new method coined BOSSANOVA (Bond Order diSSection in an ANOVA (ANalysis Of VAriance) -like fashion). It spills out configuration files for each fragment and includes joining and analyzing programs, to put together the partial energies and forces of each fragment to the total energy and forces. It allows for a complete Born-Oppenheimer molecular dynamics run.
-=======
-# Project: ParallelCarParrinello
-# Jan Hamaekers
-# Frederik Heber
-# 2005
-#
-# File: README
+... is a tool that started as a mean to edit pcp configuration files (adding/
+removing groups of atoms, measuring bond lengths and so forth), grew forth into 
+a many-body fragmentation test base of a new method coined BOSSANOVA (Bond
+Order diSSection in an ANOVA (ANalysis Of VAriance) - like fashion). It spilled 
+out configuration files for each fragment and included joining and analyzing 
+programs, to put together the partial energies and forces of each fragment to 
+the total energy and forces. Since then it has evolved into a complete toolbox
+for creating molecular systems and worlds.
 
-	Electronic Structure PACKage
-
-Is a collection of mathematical-physical programs to calculate via various ab-initio methods
-such as density functional theory or Hartree-Fock electronic(-magnetic) properties including
-the molecular (Car&Parrinello) dynamics of a many electron system. Especially, the linear
-response of the system to a external magnetic field in a perturbation approach in terms of 
-susceptibility and chemical shielding is implemented via the Density Functional Perturbation
-Theory. It was developed mainly by Jan Hamaekers (pcp) with additional code by Frederik Heber 
-(dfpt part in pcp) and also Ralf Wildenhuis (Gauss) at the Institute for Numerical Simulation 
-at the University of Bonn[1].
-
-
->>>>>>> FETCH_HEAD
 
 INSTALLATION NOTES
 ==================
 
-<<<<<<< HEAD
 The following packages are needed
 * GCC or alike
 * GSL (GNU Scientific Library, available at http://www.gnu.org/software/gsl)
 * Boost 1.4 or newer
-=======
-In general gcc or alike is needed to compile the sources, for more specific demands see the README files in the sub directory of each package part.
 
 LINKS
 =====
 [1] http://www.ins.uni-bonn.de/
->>>>>>> FETCH_HEAD
Index: TestRunnerClient.cpp
===================================================================
--- TestRunnerClient.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ TestRunnerClient.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -45,5 +45,5 @@
 #endif
 
-#define MAX_HOSTNAME_SIZE		255
+enum { MAX_HOSTNAME_SIZE=255 };
 
 /*
Index: bootstrap
===================================================================
--- bootstrap	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ bootstrap	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,14 @@
+#! /bin/sh
+# bootstrap git sources
+# This file is not distributed.
+
+set -x
+
+if git log > ChangeLog.t \
+   && diff ChangeLog.t ChangeLog >/dev/null 2>&1; then
+	mv -f ChangeLog.t ChangeLog
+else
+	rm -f ChangeLog.t
+fi
+
+autoreconf -v -i -I config -I m4
Index: configure.ac
===================================================================
--- configure.ac	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ configure.ac	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -3,5 +3,5 @@
 
 AC_PREREQ(2.59)
-AC_INIT(Molecuilder, 1.0, heber@ins.uni-bonn.de, molecuilder)
+AC_INIT(MoleCuilder, 1.0.0, heber@ins.uni-bonn.de, molecuilder)
 AC_CONFIG_AUX_DIR(config)
 AC_CONFIG_SRCDIR([src/builder.cpp])
@@ -9,5 +9,5 @@
 AC_CONFIG_MACRO_DIR([m4])
 
-AM_INIT_AUTOMAKE(dist-bzip2 parallel-tests)
+AM_INIT_AUTOMAKE([dist-bzip2 1.11 parallel-tests color-tests])
 
 # Checks for programs.
@@ -15,6 +15,4 @@
 AC_PROG_CXX
 AC_PROG_CC
-# obselete by LT_INIT
-#AC_PROG_RANLIB
 AC_PROG_INSTALL
 AC_CHECK_PROG([LATEX],[latex],[latex],[:])
@@ -82,5 +80,5 @@
 fi
 
-# add replacement/saturation hydrogen or not 
+# use CppUnit TestRunner or not
 AC_ARG_ENABLE([ecut],AS_HELP_STRING([--enable-ecut],[Use ECut TestRunnerClient (default is no)]),
               [enable_ecut=$enableval], [enable_ecut=no])
@@ -88,4 +86,24 @@
   AC_DEFINE(HAVE_ECUT,1, ["Use ECut TestRunnerClient instead of our own."])
   AC_SUBST(HAVE_ECUT)
+fi
+
+# with valgrinding testsuite or not
+AC_ARG_WITH([valgrind],AS_HELP_STRING([--with-valgrind],[Use Valgrind on the testsuite (default is no)]),
+              [with_valgrind=$withval], [with_valgrind=no])
+if test x"$with_valgrind" = xyes; then
+  AC_CHECK_HEADER([valgrind/valgrind.h],
+    [
+      # check header
+      AC_DEFINE(HAVE_VALGRIND_TESTSUITE,1, ["Use Valgrind to check the testsuite."])
+      # check path
+      AC_PATH_PROG(VALGRIND, [valgrind], [/bin/false])
+      # set variables 
+      AC_SUBST(HAVE_VALGRIND_TESTSUITE)
+      AC_SUBST(VALGRIND)
+    ],
+    [
+      AC_MSG_ERROR(["Valgrind support requested but headers not available."])
+    ]
+  )
 fi
 
@@ -128,4 +146,6 @@
 	src/Actions/Makefile
   src/Exceptions/Makefile
+  src/Helpers/Makefile
+  src/LinearAlgebra/Makefile
   src/Parser/Makefile
 	src/UIElements/Makefile
Index: src/Actions/Action.cpp
===================================================================
--- src/Actions/Action.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Action.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Action.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -18,6 +30,6 @@
 #include "UIElements/UIFactory.hpp"
 
-#include "log.hpp"
-#include "verbose.hpp"
+#include "Helpers/Log.hpp"
+#include "Helpers/Verbose.hpp"
 
 using namespace std;
Index: src/Actions/Action.hpp
===================================================================
--- src/Actions/Action.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/Action.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -87,9 +87,37 @@
  * <H2> Building your own actions </H2>
  *
- * Building actions is fairly easy. Simply derive from the abstract Action base class and implement
- * the virtual methods. The main code that needs to be executed upon call() should be implemented in
- * the performCall() method. Any user interaction should be placed into the dialog returned by
- * createDialog(). You should also indicate whether the action supports undo by implementing
- * the shouldUndo() and canUndo() methods to return the appropriate flags.
+ * Building actions is easy. Each specific ...Action is derived from the base class Action.
+ * In order to create all the reoccuring stuff, macros have been created which you can simply
+ * include and then don't need to worry about it.
+ * There are three major virtual functions: performCall(), performUndo(), performRedo() which
+ * you have to write, to equip your action with some actual capabilities.
+ * Each Action definition and implementation consists of of three files:
+ * -# cpp: contains performX() which you have to write, also some boilerplate functions which are
+ *         constructed automatically when including your def and "Actions/action_impl_pre.hpp"
+ * -# hpp: boilerplate definitions created simply by including your def and
+ *         "Actions/action_impl_header.hpp"
+ * -# def: macro definitions of all your parameters and additional variables needed for the state,
+ *         also name and category and token of your action.
+ *
+ * Best thing to do is look at one of the already present triples and you should soon understand
+ * what you have to add:
+ * -# pick the right category, i.e. the right folder in src/Actions
+ * -# pick the right name
+ * -# decide which parameters your actions need and what the type, the variable name and the token
+ *    to reference it from the command-line should be. Check whether already present and fitting
+ *    tokens exists, e.g. "position" as token for a Vector representing a position.
+ * -# consider which additional information you need to undo your action
+ * -# don't forget to include your .def file followed by "action_impl_pre.hpp" in .cpp or
+ *    "action_impl_header.hpp" in the .hpp
+ * -# continue to write the functionality of your action in performCall(), undo and redo in performUndo()
+ *    and performRedo().
+ * -# You should indicate whether the action supports undo by implementing the shouldUndo() and
+ *    canUndo() methods to return the appropriate flags.
+ *
+ * <H3> Specific notes on the macros </H3>
+ *
+ * The following functions are created by the macros, i.e. you don't need to worry about it:
+ *
+ * Any user interaction should be placed into the dialog returned by fillDialog().
  *
  * Also, create the global function to allow for easy calling of your function internally (i.e.
@@ -135,10 +163,13 @@
  *
  * <ul>
- *  <li/> derive YourAction from Action
- *  <li/> pass name and flag for registry to the base constructor
- *  <li/> implement createDialog(), performCall(), performUndo(), performRedo()
- *  <li/> implement the global function call/macro.
- *  <li/> implement the functions that return the flags for the undo mechanism
- *  <li/> Derive YourActionState from ActionState as necessary
+ *  <li/> create parameter tupels (type, token, reference), put into def. Access them later in
+ *        the performX() via the structure params.###.
+ *  <li/> think of name, category and token for your action, put into def
+ *  <li/> create additional state variables tupels (type, reference) for storing extra information
+ *        that you need for undo/redo in the ActionState. You can always access the parameters
+ *        of your Action by state.params.### (i.e. they are copied to the state by default).
+ *  <li/> implement performCall(), first line should be calling of getParametersfromValueStorage().
+ *  <li/> performUndo(), performRedo()
+ *  <li/> implement the functions that return the flags for the undo mechanism, i.e. true/false.
  * </ul>
  *
@@ -146,15 +177,9 @@
  *
  * <ul>
- *  <li/> createDialog():
- *  <ul>
- *   <li/> Call makeDialog() from the UIFactory.
- *   <li/> Call any needed Dialog->Query...() for the values you need with specific keywords.
- *   <li/> if the action needs to save a state return a custom state object
- *   <li/> otherwise return Action::success
- *  </ul>
  *  <li/> performCall():
  *  <ul>
- *   <li/> obtain parameters you need by ValueStorage::getCurrentValue, matching
- *         key words from createDialog().
+ *   <li/> first line should be calling of getParametersfromValueStorage().
+ *   <li/> Access your parameters by the structure params.### (where ### stands for the reference/
+ *         variable name chosen in the tupel).
  *   <li/> do whatever is needed to make the action work
  *   <li/> if the action was abborted return Action::failure
@@ -165,5 +190,5 @@
  *  <ul>
  *   <li/> typecast the ActionState pointer to a Pointer to YourActionState if necessary
- *   <li/> undo the action using the information from the state
+ *   <li/> undo the action using the extra information and the Action's parameters in the state
  *   <li/> produce a new state that can be used for redoing and return it
  *  </ul>
@@ -171,5 +196,5 @@
  *  <ul>
  *   <li/> take the ActionState produced by performUndo and typecast it to a pointer to YourActionState if necessary
- *   <li/> redo the undone action using the information from the state
+ *   <li/> redo the undone action using the extra information and the Action's parameters in the state
  *   <li/> produce a new state that can be used by performUndo() and return it
  *  </ul>
@@ -377,4 +402,16 @@
 private:
 
+  /**
+   * This is called internally before the Action::performCall(). It initializes the
+   * necessary ActionParameters by retrieving the values from ValueStorage.
+   */
+  virtual void getParametersfromValueStorage()=0;
+
+  /**
+   * This is called internally before the action is processed. This adds necessary queries
+   * to a given dialog to obtain parameters for the user for processing the action accordingly.
+   * The dialog will be given to the user before Action::performCall() is initiated, values
+   * are transfered via ValueStorage.
+   */
   virtual Dialog * fillDialog(Dialog*)=0;
 
@@ -420,3 +457,16 @@
 };
 
+/**
+ * This class can be used by actions to contain parameters.
+ *
+ * The base class is completely empty, since no general parameters can be given. The
+ * Action performing the function should construct its own parameter class derived
+ * from it.
+ */
+class ActionParameters{
+public:
+  ActionParameters(){}
+  virtual ~ActionParameters(){}
+};
+
 #endif /* ACTION_H_ */
Index: src/Actions/ActionHistory.cpp
===================================================================
--- src/Actions/ActionHistory.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ActionHistory.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionHistory.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
@@ -67,6 +79,9 @@
 
 /****************** Contained actions *******************/
+
+const char ActionHistory::UndoAction::NAME[] = "undo";
+
 ActionHistory::UndoAction::UndoAction(ActionHistory *_hist) :
-  Action("Undo"),
+  Action(NAME),
   hist(_hist)
 {}
@@ -86,4 +101,7 @@
 }
 
+void ActionHistory::UndoAction::getParametersfromValueStorage()
+{}
+
 Dialog* ActionHistory::UndoAction::fillDialog(Dialog *dialog){
   ASSERT(dialog,"No Dialog given when filling action dialog");
@@ -92,4 +110,5 @@
 
 Action::state_ptr ActionHistory::UndoAction::performCall(){
+  std::cout << "Undo" << std::endl;
   hist->undoLast();
   return Action::success;
@@ -106,6 +125,8 @@
 }
 
+const char ActionHistory::RedoAction::NAME[] = "redo";
+
 ActionHistory::RedoAction::RedoAction(ActionHistory *_hist) :
-    Action("Redo"),
+    Action(NAME),
     hist(_hist)
 {}
@@ -125,4 +146,7 @@
 }
 
+void ActionHistory::RedoAction::getParametersfromValueStorage()
+{}
+
 Dialog* ActionHistory::RedoAction::fillDialog(Dialog *dialog){
   ASSERT(dialog,"No Dialog given when filling action dialog");
@@ -131,4 +155,5 @@
 
 Action::state_ptr ActionHistory::RedoAction::performCall(){
+  std::cout << "Redo" << std::endl;
   hist->redoLast();
   return Action::success;
Index: src/Actions/ActionHistory.hpp
===================================================================
--- src/Actions/ActionHistory.hpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ActionHistory.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -41,9 +41,12 @@
     virtual Dialog * fillDialog(Dialog *dialog);
   private:
-    virtual Action::state_ptr performCall();
+    virtual void getParametersfromValueStorage();
+  virtual Action::state_ptr performCall();
     virtual Action::state_ptr performUndo(Action::state_ptr);
     virtual Action::state_ptr performRedo(Action::state_ptr);
 
     ActionHistory *hist;
+
+    static const char NAME[];
   };
 
@@ -61,4 +64,5 @@
     virtual Dialog * fillDialog(Dialog *dialog);
   private:
+    virtual void getParametersfromValueStorage();
     virtual Action::state_ptr performCall();
     virtual Action::state_ptr performUndo(Action::state_ptr);
@@ -66,4 +70,6 @@
 
     ActionHistory *hist;
+
+    static const char NAME[];
   };
 
Index: src/Actions/ActionRegistry.cpp
===================================================================
--- src/Actions/ActionRegistry.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ActionRegistry.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * Registry<Action>.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/ActionSequence.cpp
===================================================================
--- src/Actions/ActionSequence.cpp	(revision 45924c1c4900321275c7d22c75650d2dcff4a2c1)
+++ src/Actions/ActionSequence.cpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -1,2 +1,9 @@
+/*
+ * Project: MoleCuilder
+ * Description: creates and alters molecular systems
+ * Copyright (C)  2010 University of Bonn. All rights reserved.
+ * Please see the LICENSE file or "Copyright notice" in builder.cpp for details.
+ */
+
 /*
  * ActionSequenze.cpp
@@ -5,4 +12,9 @@
  *      Author: crueger
  */
+
+// include config.h
+#ifdef HAVE_CONFIG_H
+#include <config.h>
+#endif
 
 #include "Helpers/MemDebug.hpp"
Index: src/Actions/Action_impl_header.hpp
===================================================================
--- src/Actions/Action_impl_header.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
+++ src/Actions/Action_impl_header.hpp	(revision a6e6b5ce7c3675b17615ce9fc4f938f0ccc32ef7)
@@ -0,0 +1,132 @@
+/*
+ * Action_impl_header.hpp
+ *
+ *  Created on: Aug 25, 2010
+ *      Author: heber
+ */
+
+#include <boost/preprocessor/cat.hpp>
+#include <boost/preprocessor/comparison/equal.hpp>
+#include <boost/preprocessor/comparison/not_equal.hpp>
+#include <boost/preprocessor/control/if.hpp>
+#include <boost/preprocessor/debug/assert.hpp>
+#include <boost/preprocessor/iteration/local.hpp>
+#include <boost/preprocessor/punctuation/comma_if.hpp>
+#include <boost/preprocessor/repetition/repeat.hpp>
+#include <boost/preprocessor/seq/elem.hpp>
+#include <boost/preprocessor/seq/push_back.hpp>
+#include <boost/preprocessor/seq/seq.hpp>
+#include <boost/preprocessor/seq/size.hpp>
+#include <boost/preprocessor/seq/transform.hpp>
+
+// some derived names
+#define ACTION BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Action))
+#define COMMAND BOOST_PP_CAT(CATEGORY, ACTIONNAME)
+#define PARAMS BOOST_PP_CAT(CATEGORY, BOOST_PP_CAT(ACTIONNAME, Parameters))
+
+// check if no lists given
+#ifndef paramtypes
+#define MAXPARAMTYPES 0
+#else
+#define MAXPARAMTYPES BOOST_PP_SEQ_SIZE(paramtypes)
+#endif
+
+// check user has given name and category
+#ifndef CATEGORY
+ERROR: No "CATEGORY" defined in: __FILE__
+#endif
+
+#ifndef ACTIONNAME
+ERROR: No "ACTIONNAME" defined in: __FILE__
+#endif
+
+// calculate numbers and check whether all have same size
+#ifdef paramtokens
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXPARAMTYPES, BOOST_PP_SEQ_SIZE(paramtokens)),\
+  ERROR: There are not the same number of "paramtokens" and "paramtypes" in: __FILE__ \
+)
+#endif
+#ifdef paramreferences
+BOOST_PP_ASSERT_MSG(BOOST_PP_EQUAL(MAXPARAMTYPES, BOOST_PP_SEQ_SIZE(paramreferences)),\
+  ERROR: There are not the same number of "paramtokens" and "paramreferences" in: __FILE__ \
+)
+#endif
+
+// print a list of type ref followed by a separator, i.e. "int i;"
+#define type_print(z,n,TYPELIST, VARLIST, separator) \
+  BOOST_PP_SEQ_ELEM(n, TYPELIST) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST)\
+  separator
+
+// print a list of type ref followed, i.e. "int i, double position"
+#define type_list(z,n,TYPELIST, VARLIST) \
+  BOOST_PP_COMMA_IF(n)\
+  BOOST_PP_SEQ_ELEM(n, TYPELIST) \
+  BOOST_PP_SEQ_ELEM(n, VARLIST)
+
+#if defined paramtypes && defined paramreferences
+void COMMAND(
+#define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, paramtypes, paramreferences)
+#define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+#include BOOST_PP_LOCAL_ITERATE()
+    );
+# else
+void COMMAND();
+#endif
+
+class ACTION : public Action {
+  friend
+  #if defined paramtypes && defined paramreferences
+  void COMMAND(
+  #define BOOST_PP_LOCAL_MACRO(n) type_list(~, n, paramtypes, paramreferences)
+  #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+  #include BOOST_PP_LOCAL_ITERATE()
+      );
+  # else
+  void COMMAND();
+  #endif
+
+public:
+  ACTION();
+  virtual ~ACTION();
+
+  bool canUndo();
+  bool shouldUndo();
+
+  virtual const std::string getName();
+
+  struct PARAMS : ActionParameters {
+  #if defined paramtypes && defined paramreferences
+  #define BOOST_PP_LOCAL_MACRO(n) type_print(~, n, paramtypes, paramreferences, ;)
+  #define BOOST_PP_LOCAL_LIMITS  (0, MAXPARAMTYPES-1)
+  #include BOOST_PP_LOCAL_ITERATE()
+  #endif
+  } params;
+
+protected:
+  virtual Dialog * fillDialog(Dialog*);
+private:
+  virtual void getParametersfromValueStorage();
+  virtual Action::state_ptr performCall();
+  virtual Action::state_ptr performUndo(Action::state_ptr);
+  virtual Action::state_ptr performRedo(Action::state_ptr);
+
+  static const char NAME[];
+};
+
+#undef paramtypes
+#undef paramtokens
+#undef paramreferences
+#undef MAXPARAMTYPES
+#undef statetypes
+#undef statereferences
+#undef MAXSTATETYPES
+
+#undef ACTION
+#undef COMMAND
+#undef COMMANDFULL
+#undef PARAMS
+
+#undef ACTIONNAME
+#undef CATEGORY
+#undef TOKEN
